import React from "react";
import classNames from "classnames";
import {LoggerFactory} from "reakit/src/utils";
import styles from "./styles";

let Logger = new LoggerFactory("container", {level:"error"});

/**
 * Main component class.
 */
export default class Component extends React.Component {
    /** React properties **/
    static displayName = "container";
    static defaultProps = {};
    static propTypes = {};

    componentDidMount() {
        let logger = Logger.create("componentDidMount");
        logger.info("enter");
    }

    render() {
        let classes = [
            styles.container,
            this.props.className
        ];

        return (
            <div className={classNames(classes)}>
                {this.props.children}
            </div>
        );
    }
}
