import {createActions} from "redux-actions";
import {LoggerFactory,Http} from "reakit/src/utils";

let Logger = new LoggerFactory("i18n.actions", {level:"error"});
let http = new Http();

export default createActions({
    i18NInit(lang = "pt-br") {
        var logger = Logger.create("init");
        logger.info("enter", {lang});

        return http.request("GET", `/assets/i18n/${lang}.json`)
        .catch(() => {
            // Something went wrong : fetch en-US file.
            return http.request("GET", "/assets/i18n/en-US.json");
        });
    }
});
